' ########################################################################################
' Microsoft Hierarchical Grid Control Demo
' ########################################################################################

#COMPILE EXE
#DIM ALL
#INCLUDE ONCE "ADO.INC"
#INCLUDE ONCE "MSHFLXGD.INC"
#INCLUDE ONCE "OLECON.INC"

%IDC_GRID = 1001

' ========================================================================================
' Main
' ========================================================================================
FUNCTION WINMAIN (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

   LOCAL hDlg AS DWORD

   ' Required: Initialize the Ole Container
   OC_WinInit

   DIALOG NEW 0, "Microsoft Hierarchical Flex Grid", , , 530, 346, %WS_OVERLAPPED OR %WS_THICKFRAME OR %WS_SYSMENU OR _
   %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX OR %WS_VISIBLE OR %DS_CENTER TO hDlg
   ' For icon from resource, instead use something like, LoadIcon(hInst, "APPICON")
   DIALOG SEND hDlg, %WM_SETICON, %ICON_SMALL, LoadIcon(%NULL, BYVAL %IDI_APPLICATION)
   DIALOG SEND hDlg, %WM_SETICON, %ICON_BIG, LoadIcon(%NULL, BYVAL %IDI_APPLICATION)

   ' We need to forward the messages to the control for keyboard handling
   ' and for that we need a message pump, so the dialog must be modeless.
   DIALOG SHOW MODELESS hDlg, CALL DlgProc

   ' Message handler loop
   LOCAL uMsg AS tagMsg
   WHILE GetMessage(uMsg, %NULL, 0, 0)
      IF ISFALSE OC_ForwardMessage(GetFocus, uMsg) THEN
         IF IsDialogMessage(hDlg, uMsg) = 0 THEN
            TranslateMessage uMsg
            DispatchMessage uMsg
         END IF
      END IF
   WEND

END FUNCTION
' ========================================================================================

' ========================================================================================
' Main Dialog procedure
' ========================================================================================
CALLBACK FUNCTION DlgProc() AS LONG

   LOCAL  hr AS LONG                          ' // HRESULT code
   LOCAL  rc AS RECT                          ' // RECT structure
   LOCAL  hGrid AS DWORD                      ' // Grid's handle
   LOCAL  pGrid AS IMSHFlexGrid               ' // IMSFlexGrid interface reference

   SELECT CASE CBMSG

      CASE %WM_INITDIALOG

         ' Create a registration-free instance of the MSHFlexGrid control
         LOCAL cp AS OC_CREATEPARAMS
         cp.clsid = $CLSID_MSHFlexGrid
         cp.riid = $IID_IMSHFlexGrid
         cp.szLicKey = $RTLKEY_MSHFlexGrid
         cp.szLibName = EXE.Path$ & "MSHFLXGD.OCX"
         hGrid = CreateWindowEx(0, $OC_CLASSNAME, "", _
            %WS_CHILD OR %WS_VISIBLE OR %WS_BORDER OR %WS_TABSTOP, _
            0, 0, 0, 0, CB.HNDL, %IDC_GRID, GetModuleHandle(BYVAL %NULL), cp)

         ' Get a reference to the Grid control
         pGrid = OC_GetDispatch(hGrid)

         IF ISOBJECT(pGrid) THEN

            ' Change the width of the columns (measures are in twips)
            ' The first parameter is the grid's pointer reference,
            ' the second the column index, and the third the col width.
            pGrid.ColWidth( 0,0) = 300
            pGrid.ColWidth( 1,0) = 1000
            pGrid.ColWidth( 2,0) = 3000
            pGrid.ColWidth( 3,0) = 2000
            pGrid.ColWidth( 4,0) = 2000
            pGrid.ColWidth( 5,0) = 3000
            pGrid.ColWidth( 6,0) = 1500
            pGrid.ColWidth( 7,0) = 700
            pGrid.ColWidth( 8,0) = 1200
            pGrid.ColWidth( 9,0) = 1200
            pGrid.ColWidth(10,0) = 1500
            pGrid.ColWidth(11,0) = 1500

            ' *** Set the default font for all the cells ***
            LOCAL pFont AS IDispatch
            hr = OleCreateFontDisp("Verdana", 8, %FW_BOLD, %ANSI_CHARSET, 0, 0, 0, pFont)
            IF ISOBJECT(pFont) THEN
               pGrid.putref_Font = pFont
               pFont = NOTHING
            END IF

            ' Change the foreground and background colors
            pGrid.ForeColor = %BLACK
            pGrid.BackColor = RGB(255,255,235)

            ' Create an ADO connection object
            LOCAL pCon AS ADOConnection
            pCon = NEWCOM "ADODB.Connection"
            IF ISOBJECT(pCon) THEN
               ' Connection string - Remember to change the path of the Data Source if needed
               LOCAL ConStr AS STRING
               ConStr = UCODE$("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & EXE.Path$ & "NWIND.mdb")
               ' Set the connection string
               pCon.ConnectionString = ConStr
               ' Open the database
               pCon.Open
               IF OBJRESULT = %S_OK THEN
                  ' Create an ADO recordset object
                  LOCAL pRec AS ADORecordset
                  pRec = NEWCOM "ADODB.Recordset"
                  IF ISOBJECT(pRec) THEN
                     ' Open the recordset
                     LOCAL SqlStr AS STRING
                     SqlStr = "SELECT * FROM Customers"
                     pRec.Open SqlStr, pCon, %adOpenKeyset, %adLockOptimistic, %adCmdText
                     ' Get the Datasource property of the recordset
                     LOCAL pDataSource AS IUnknown
                     pDataSource = pRec.DataSource
                     IF ISOBJECT(pDataSource) THEN
                        ' Bind the recordset to the grid
                        pGrid.putref_DataSource = pDataSource
                        pDataSource = NOTHING
                     END IF
                     ' Close the recordset
                     pRec.Close
                     pRec = NOTHING
                  END IF
                  ' Close the connection
                  pCon.Close
               END IF
               pCon = NOTHING
            END IF

            pGrid = NOTHING

         END IF

      CASE %WM_SIZE
         ' Resize the grid
         IF CB.WPARAM <> %SIZE_MINIMIZED THEN
            GetClientRect CB.HNDL, rc
            MoveWindow GetDlgItem(CB.HNDL, %IDC_GRID), 0, 0, (rc.nRight - rc.nLeft), (rc.nBottom - rc.nTop), %TRUE
         END IF

      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDOK
               IF CB.CTLMSG = %BN_CLICKED THEN
               END IF
            CASE %IDCANCEL
               IF CB.CTLMSG = %BN_CLICKED THEN DIALOG END CB.HNDL, 0
         END SELECT

      ' --> Note: Both WM_SYSCOMMAND and WM_DESTROY are required with this control <--

      CASE %WM_SYSCOMMAND
         ' Capture this message and send a %WM_CLOSE message,
         ' or the program will remain in memory
         IF (CB.WPARAM AND &HFFF0) = %SC_CLOSE THEN
            DIALOG SEND CB.HNDL, %WM_CLOSE, 0, 0
         END IF

      CASE %WM_DESTROY
         PostQuitMessage 0

   END SELECT

END FUNCTION
' ========================================================================================

